/*****************************************/
/* Assignment# 3                         */
/* Wriiten By:                           */
/* Srinivasa Rao Chava                   */
/*****************************************/

#include <stdio.h>
#include "mpi.h"

#define N_Dim 2  /* Number of dimensions*/

 /* taking 2 X 2 mesh and total procesrs are 4*/
#define xprocessors 2 /* processors in x-axis direction*/
#define yprocessors 2 /* processors in y-axix direction*/

#define ypoints 1024.0 /* number of intervals in x_direction*/
#define xpoints 1024.0 /* number of intervals in y-direction*/
double f(double x, double y);

double sqrt();

main(argc, argv)

int argc;
char **argv;
{
  MPI_Comm comm2d; /* new communicator after creating cartesian topology*/
  int myrank,size, reorder;
  int left, right,top,bottom;
  double a[4]; /* buffer to recevie the values from different preocessrs
                 at processors zero*/
  int A;      
  double sum=0.0;/* sum of all the values calculated at different processors*/
  int dims[N_Dim],  /*number of processor dimension*/
      local[N_Dim],  /* local row and column position*/
      period[N_Dim]; /* periodic flag*/
      int num_proc_x,num_proc_y;  /* coordinates  x , y */   

  /* maximun number of grids for each processor in each direction
    i.e local_n X local_n points */
int local_n= xpoints/2;  

int local_i=0.0;
int local_j=0.0;
int i=0;
int j=0;

double x=0.0;
double  y=0.0; 
double h=1/xpoints;
int limn_i=0.0;
int limn_j= 0.0;
int s=0;
int t= 0;
double pisqured=0.0;
MPI_Init(&argc,&argv);
MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
MPI_Comm_size(MPI_COMM_WORLD, &size);
if(size !=4)
 {
   if(myrank == 0){
     fprintf(stderr,"Please select 4 nodes as the programm is written using 2 X 2 mesh !!!!\n");
     fflush(stderr);} 
MPI_Finalize();
exit(1);
   }

  /* Creating a new communicator with cartesian toplogy*/

dims[0]= xprocessors;
dims[1]= yprocessors;
period[0]=1;
period[1]=1;
reorder=0;
MPI_Cart_create(MPI_COMM_WORLD, N_Dim,dims,period,reorder,&comm2d);
MPI_Cart_coords(comm2d,myrank,N_Dim, local);
num_proc_y=local[0];
num_proc_x=local[1];

 
  /* calucalting starting point of each processors */
local_i=i+(num_proc_x * local_n );
local_j= j+(num_proc_y * local_n);

  /* Calculating limiting values in each direction */ 
limn_i=local_i+local_n;
limn_j=local_j+local_n; 

  /* Computing PI^2 values over each processor block */
for( s=local_i; s< limn_i; s++)
{ 
 for( t=local_j; t<limn_j; t++)
     { 
       x=s*h;
       y =t*h;
       pisqured= pisqured+(h*h)*(f(x,y)+f(x,y+h)+f(x+h,y)+f(x+h,y+h))/4;      
         }
   }
pisqured=pisqured*16;

  /* All the computed values from different processors are gathered at process zero */
MPI_Gather(&pisqured, 1,MPI_DOUBLE,a,1,MPI_DOUBLE,0,MPI_COMM_WORLD);


  /* The gathered values are summed at process zero */
if(myrank==0){
  for(A=0;A<4;A++)
      sum= sum+ a[A];
printf("pisqured value is %.16f \n",sum);
printf("pi value is %.16f \n", sqrt(sum));
                   }
                
MPI_Finalize();
} /* main*/

 /*  function f(x,y */
double f(double x, double y)
    { double retval;
      retval= ((double)1/(((double)1+ x*x)*((double)1+y*y)));
      return retval;} /* f*/
      

